
var xpunge_mu_consoleService = Components.classes['@mozilla.org/consoleservice;1'].
			getService(Components.interfaces.nsIConsoleService);


var xpunge_mu_prefBranch = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);



function xpunge_doMultiple ()
{
	if (!messenger)
	{
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "ERROR - No Messenger Object!" + "\n");

		return;
	}

	var l_selectedFolderServer = "";

	var l_selectedFolders = GetSelectedMsgFolders();

	if (l_selectedFolders.length == 1)
	{
		var l_selectedFolder = l_selectedFolders[0];
		var l_resource = l_selectedFolder.QueryInterface(Components.interfaces.nsIRDFResource);

		if (l_selectedFolder.server.type != "imap") //can be local only
		{
			var l_msgfolder = l_resource.QueryInterface(Components.interfaces.nsIMsgFolder);
			var l_expungedBytes = l_msgfolder.expungedBytes;

			if (l_expungedBytes > 0)
			{
				l_selectedFolderServer = l_selectedFolder.server.serverURI;
			}
		}
	}

	var TrashSeparatorRegExp = /   /;
	var CompactSeparatorRegExp = /   /;

	var pref_trash = xpunge_mu_prefBranch.getCharPref("xpunge.options.multi.trash.accounts");
	var pref_compact = xpunge_mu_prefBranch.getCharPref("xpunge.options.multi.compact.accounts");

	var trash_array = pref_trash.split(TrashSeparatorRegExp);
	var compact_array = pref_compact.split(CompactSeparatorRegExp);

	for (var i = 0; i < trash_array.length; i++)
	{
		if (trash_array[i] == "")
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "ERROR - Empty Trash Account Entry: Index = " + i + "\n");

			continue;
		}

		var msgfolder = GetMsgFolderFromUri(trash_array[i],true);

		if (!msgfolder)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "ERROR - Invalid Trash Account: " + trash_array[i] + "\n");

			continue;
		}

		if (!msgfolder.isServer)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "ERROR - Trash Account Is Not A Server: " + trash_array[i] + "\n");

			continue;
		}

		if (msgfolder.name == "")
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "WARNING - Trash Account Has No Name: " + trash_array[i] + "\n");

			continue;
		}

		try
		{
			var resource = msgfolder.QueryInterface(Components.interfaces.nsIRDFResource);

			if (xpunge_canEmptyTrashMulti(msgfolder))
			{
				messenger.EmptyTrash(GetFolderDatasource(),resource);
			}
		}
		catch (e)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple EXCEPTION 1: " + trash_array[i] + "\n\n" + e + "\n");
		}
	}

	for (var i = 0; i < compact_array.length; i++)
	{
		if (compact_array[i] == "")
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "ERROR - Empty Compact Account/Folder Entry: Index = " + i + "\n");

			continue;
		}

		var msgfolder = GetMsgFolderFromUri(compact_array[i],true);

		if (!msgfolder)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "ERROR - Invalid Compact Account/Folder: " + compact_array[i] + "\n");

			continue;
		}

		if (msgfolder.name == "")
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple:" + "\n\n" + "WARNING - Compact Account/Folder Has No Name: " + compact_array[i] + "\n");

			continue;
		}

		try
		{
			var resource = msgfolder.QueryInterface(Components.interfaces.nsIRDFResource);

			if (xpunge_canCompactFoldersMulti(msgfolder))
			{
				if (msgfolder.server.serverURI == l_selectedFolderServer)
				{
					if (gDBView)
					{
						gCurrentlyDisplayedMessage = gDBView.currentlyDisplayedMessage;
					}

					ClearThreadPaneSelection();
					ClearThreadPane();
					ClearMessagePane();
				}

				if (msgfolder.isServer)
				{
					messenger.CompactFolder(GetFolderDatasource(),resource,true);
				}
				else
				{
					messenger.CompactFolder(GetFolderDatasource(),resource,false);
				}
			}
		}
		catch (e)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_doMultiple EXCEPTION 2: " + compact_array[i] + "\n\n" + e + "\n");
		}
	}
}


function xpunge_canEmptyTrashMulti (folder)
{
	var server = folder.server;

	if (!server)
	{
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashMulti:" + "\n\n" + "ERROR - Invalid Server Property: " + folder.URI + "\n");

		return false;
	}

	var serverType = server.type;

	if (serverType == "nntp")
	{
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashMulti:" + "\n\n" + "WARNING - Cannot Empty Trash On An NNTP Server: " + folder.URI + "\n");

		return false;
	}
	else if (serverType == "imap")
	{
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

		if (ioService.offline)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashMulti:" + "\n\n" + "WARNING - Cannot Empty Trash On An IMAP Server While Being Offline: " + folder.URI + "\n");

			return false;
		}

		return true;
	}
	else
	{
		return true;
	}
}


function xpunge_canCompactFoldersMulti (folder)
{
	var server = folder.server;

	if (!server)
	{
		xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n" + "ERROR - Invalid Server Property: " + folder.URI + "\n");

		return false;
	}

	if (folder.isServer)
	{
		if (!server.canCompactFoldersOnServer)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n" + "ERROR - Compacting Folders Not Allowed On Server: " + folder.URI + "\n");

			return false;
		}
	}
	else
	{
		if (!folder.canCompact)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n" + "ERROR - Compacting Folder Not Allowed: " + folder.URI + "\n");

			return false;
		}
	}

	var serverType = server.type;

	if (serverType == "imap")
	{
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

		if (ioService.offline)
		{
			xpunge_mu_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersMulti:" + "\n\n" + "WARNING - Cannot Compact Folders On An IMAP Server While Being Offline: " + folder.URI + "\n");

			return false;
		}

		return true;
	}
	else
	{
		return true;
	}
}

