
var xpunge_si_consoleService = Components.classes['@mozilla.org/consoleservice;1'].
			getService(Components.interfaces.nsIConsoleService);


var xpunge_si_prefBranch = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);


var xpunge_si_selectedFolder = null;


function xpunge_doSingle ()
{
	var empty_trash = xpunge_si_prefBranch.getBoolPref("xpunge.options.single.trash");

	var compact_folders = xpunge_si_prefBranch.getBoolPref("xpunge.options.single.compact");

	xpunge_si_selectedFolder = null;
	var trash_folder_uri = "";

	var selectedFolders = GetSelectedMsgFolders();

	if (selectedFolders.length == 1)
	{
		var selectedFolder = selectedFolders[0];
		var resource = selectedFolder.QueryInterface(Components.interfaces.nsIRDFResource);

		xpunge_si_selectedFolder = resource.QueryInterface(Components.interfaces.nsIMsgFolder);

		// Check if the Trash folder is selected
		if (selectedFolder.server.type != "imap")
		{
			try
			{
				if ((!xpunge_si_selectedFolder.isServer) && (xpunge_si_selectedFolder.prettyName == "Trash") && (xpunge_si_selectedFolder.parent.URI == xpunge_si_selectedFolder.server.serverURI))
				{
					trash_folder_uri = xpunge_si_selectedFolder.URI;
				}
			}
			catch (e)
			{
				xpunge_si_consoleService.logStringMessage("xpunge - xpunge_doSingle EXCEPTION 1:" + "\n\n" + e + "\n");
			}
		}
	}

	try
	{
		if ((empty_trash) && (xpunge_canEmptyTrashSingle()))
		{
			MsgEmptyTrash();
		}

		// Select the Trash folder again for compacting to work
		if (trash_folder_uri != "")
		{
			SelectFolder(trash_folder_uri);
		}

		if ((compact_folders) && (xpunge_canCompactFoldersSingle()))
		{
			MsgCompactFolder(true);	
		}
	}
	catch (e)
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_doSingle EXCEPTION 2:" + "\n\n" + e + "\n");
	}
}


function xpunge_canEmptyTrashSingle ()
{
	if (!xpunge_si_selectedFolder)
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashSingle:" + "\n\n" + "WARNING - There Are Multiple Folders Selected!" + "\n");

		return false;
	}

	var server = xpunge_si_selectedFolder.server;

	if (!server)
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashSingle:" + "\n\n" + "ERROR - Invalid Server Property: " + xpunge_si_selectedFolder.URI + "\n");

		return false;
	}

	var serverType = server.type;

	if (serverType == "nntp")
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashSingle:" + "\n\n" + "WARNING - Cannot Empty Trash On An NNTP Server: " + xpunge_si_selectedFolder.URI + "\n");

		return false;
	}
	else if (serverType == "imap")
	{
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

		if (ioService.offline)
		{
			xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canEmptyTrashSingle:" + "\n\n" + "WARNING - Cannot Empty Trash On An IMAP Server While Being Offline: " + xpunge_si_selectedFolder.URI + "\n");

			return false;
		}

		return true;
	}
	else
	{
		return true;
	}
}


function xpunge_canCompactFoldersSingle ()
{
	if (!xpunge_si_selectedFolder)
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersSingle:" + "\n\n" + "WARNING - There Are Multiple Folders Selected!" + "\n");

		return false;
	}

	var server = xpunge_si_selectedFolder.server;

	if (!server)
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersSingle:" + "\n\n" + "ERROR - Invalid Server Property: " + xpunge_si_selectedFolder.URI + "\n");

		return false;
	}

	if (!server.canCompactFoldersOnServer)
	{
		xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersSingle:" + "\n\n" + "WARNING - Compacting Folders Not Allowed On Server: " + xpunge_si_selectedFolder.URI + "\n");

		return false;
	}

	var serverType = server.type;

	if (serverType == "imap")
	{
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

		if (ioService.offline)
		{
			xpunge_si_consoleService.logStringMessage("xpunge - xpunge_canCompactFoldersSingle:" + "\n\n" + "WARNING - Cannot Compact Folders On An IMAP Server While Being Offline: " + xpunge_si_selectedFolder.URI + "\n");

			return false;
		}

		return true;
	}
	else
	{
		return true;
	}
}

