
var xpunge_multi_consoleService = Components.classes['@mozilla.org/consoleservice;1'].
			getService(Components.interfaces.nsIConsoleService);

const xpunge_multi_NO_URI = "none";

var xpunge_multi_TrashAccountSeparator = "   ";
var xpunge_multi_CompactAccountSeparator = "   ";

var xpunge_multi_TrashAccountSeparatorRegExp = /   /;
var xpunge_multi_CompactAccountSeparatorRegExp = /   /;



function xpunge_multi_LoadOptions () 
{
	xpunge_multi_LoadTrashOptions();
	xpunge_multi_LoadCompactOptions();
}


function xpunge_multi_LoadTrashOptions ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var pref_trash_account = prefBranch.getCharPref("xpunge.options.multi.trash.accounts");

	if (pref_trash_account == "")
	{
		xpunge_multi_setTrashAccountCounter();
	}
	else
	{
		var trash_account_array = pref_trash_account.split(xpunge_multi_TrashAccountSeparatorRegExp);

		var do_fix_trash = false;

		for (var j = 0; j < trash_account_array.length; j++)
		{
			if (!xpunge_multi_isValidTrashAccountEntry(j,trash_account_array[j],"xpunge_multi_LoadTrashOptions"))
			{
				do_fix_trash = true;

				continue;
			}

			var msgfolder = GetMsgFolderFromUri(trash_account_array[j],true);

			xpunge_multi_appendTrashAccount(msgfolder.name,trash_account_array[j]);
		}

		xpunge_multi_ensureTrashAccountIsVisible(0);
		xpunge_multi_setTrashAccountCounter();

		if (do_fix_trash)
			xpunge_multi_fixInvalidSelectedTrashAccounts();
	}
}


function xpunge_multi_LoadCompactOptions ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var pref_compact_account = prefBranch.getCharPref("xpunge.options.multi.compact.accounts");

	if (pref_compact_account == "")
	{
		xpunge_multi_setCompactAccountCounter();
	}
	else
	{
		var compact_account_array = pref_compact_account.split(xpunge_multi_CompactAccountSeparatorRegExp);

		var do_fix_compact = false;

		for (var j = 0; j < compact_account_array.length; j++)
		{
			if (!xpunge_multi_isValidCompactAccountEntry(j,compact_account_array[j],"xpunge_multi_LoadCompactOptions"))
			{
				do_fix_compact = true;

				continue;
			}

			var msgfolder = GetMsgFolderFromUri(compact_account_array[j],true);

			var item_name;
			var server_name;

			if (msgfolder.isServer)
			{
				item_name = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_whole");
			}
			else
			{
				if (msgfolder.server)
					server_name = msgfolder.server.prettyName;
				else
				{
					xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_LoadCompactOptions:" + "\n\n" + "ERROR - Can't find server for " + compact_account_array[j] + "\n");
					server_name = "???";
				}

				item_name = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_belongs") + " " + server_name;
			}

			xpunge_multi_appendCompactAccount(item_name,compact_account_array[j]);
		}

		xpunge_multi_ensureCompactAccountIsVisible(0);
		xpunge_multi_setCompactAccountCounter();

		if (do_fix_compact)
			xpunge_multi_fixInvalidSelectedCompactAccounts();
	}
}


function xpunge_multi_SaveOptions () 
{
	xpunge_multi_SaveTrashOptions();
	xpunge_multi_SaveCompactOptions();
}


function xpunge_multi_SaveTrashOptions () 
{
	var log_msg = "";
	var do_fix = false;

	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_multi_isValidTrashAccountEntry(0,account_value,"xpunge_multi_SaveTrashOptions"))
		{
			pref_account = account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + "0" + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_multi_isValidTrashAccountEntry(j,account_value,"xpunge_multi_SaveTrashOptions"))
		{
			pref_account = pref_account + xpunge_multi_TrashAccountSeparator + account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + j + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}

	prefBranch.setCharPref("xpunge.options.multi.trash.accounts",pref_account);

	if (do_fix)
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_SaveTrashOptions:" + "\n\n" + log_msg + "\n");

		alert(document.getElementById("xpunge_strings").getString("xpunge_multi_str_trash_save_fixed_msg"));
	}
}


function xpunge_multi_SaveCompactOptions () 
{
	var log_msg = "";
	var do_fix = false;

	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_multi_isValidCompactAccountEntry(0,account_value,"xpunge_multi_SaveCompactOptions"))
		{
			pref_account = account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + "0" + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_multi_isValidCompactAccountEntry(j,account_value,"xpunge_multi_SaveCompactOptions"))
		{
			pref_account = pref_account + xpunge_multi_CompactAccountSeparator + account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + j + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}

	prefBranch.setCharPref("xpunge.options.multi.compact.accounts",pref_account);

	if (do_fix)
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_SaveCompactOptions:" + "\n\n" + log_msg + "\n");

		alert(document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_save_fixed_msg"));
	}
}


function xpunge_multi_appendTrashAccount (v_account, v_tooltip)
{
	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	accounts.appendItem(v_account);

	var item = accounts.getItemAtIndex(accounts.getRowCount()-1);

	item.setAttribute('tooltiptext',v_tooltip);

	xpunge_multi_ensureTrashAccountIsVisible(accounts.getRowCount()-1);
}


function xpunge_multi_appendCompactAccount (v_account, v_tooltip)
{
	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	accounts.appendItem(v_account);

	var item = accounts.getItemAtIndex(accounts.getRowCount()-1);

	item.setAttribute('tooltiptext',v_tooltip);

	xpunge_multi_ensureCompactAccountIsVisible(accounts.getRowCount()-1);
}


function xpunge_multi_SetTrashFolderPicker (selection, pickerID, defaultURI)
{
	var picker = document.getElementById(pickerID);

	var uri;

	if (selection != null)
	{
		uri = selection.getAttribute('id');
	}
	else
	{
		uri = defaultURI;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder) 
	{
		picker.setAttribute("uri",xpunge_multi_NO_URI);
	}
	else
	{
		picker.setAttribute("uri",uri);

		var button_add = document.getElementById("xpunge_options_multi_trash_add");

		button_add.disabled = false;
	}
}


function xpunge_multi_SetCompactFolderPicker (selection, pickerID, defaultURI)
{
	var picker = document.getElementById(pickerID);

	var uri;

	if (selection != null)
	{
		uri = selection.getAttribute('id');
	}
	else
	{
		uri = defaultURI;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder) 
	{
		picker.setAttribute("uri",xpunge_multi_NO_URI);
	}
	else
	{
		var selectedValue = null;
		var serverName;

		if (msgfolder.isServer)
			selectedValue = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_whole");
		else
		{
			if (msgfolder.server)
				serverName = msgfolder.server.prettyName;
			else
			{
				xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_SetCompactFolderPicker:" + "\n\n" + "ERROR - Can't find server for " + uri + "\n");
				serverName = "???";
			}

			selectedValue = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_belongs") + " " + serverName;
		}

		picker.setAttribute("label",selectedValue);
		picker.setAttribute("uri",uri);

		var button_add = document.getElementById("xpunge_options_multi_compact_add");

		button_add.disabled = false;
	}
}


function xpunge_multi_doAddTrashAccounts () 
{
	var picker = document.getElementById("xpunge_options_multi_trash_picker");

	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	var selection = picker.getAttribute("label");

	var uri = picker.getAttribute("uri");

	if (uri == xpunge_multi_NO_URI)
	{
		alert(document.getElementById("xpunge_strings").getString("xpunge_multi_str_trash_invalid_account"));

		return;
	}

	var rows = accounts.getRowCount();

	for (var i = 0; i < rows; i++)
	{
		var account_elem = accounts.getItemAtIndex(i);

		if (account_elem.getAttribute("tooltiptext") == uri)
		{
			if (account_elem.getAttribute("label") != selection)
			{
				account_elem.setAttribute("label",selection);
			}
			else
			{
				alert(document.getElementById("xpunge_strings").getString("xpunge_multi_str_trash_already_added"));
			}

			return;
		}
	}

	xpunge_multi_appendTrashAccount(selection,uri);

	xpunge_multi_setTrashAccountCounter();
}


function xpunge_multi_doAddCompactAccounts () 
{
	var picker = document.getElementById("xpunge_options_multi_compact_picker");

	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	var selection = picker.getAttribute("label");

	var uri = picker.getAttribute("uri");

	if (uri == xpunge_multi_NO_URI)
	{
		alert(document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_invalid_account"));

		return;
	}

	var rows = accounts.getRowCount();

	for (var i = 0; i < rows; i++)
	{
		var account_elem = accounts.getItemAtIndex(i);

		if (account_elem.getAttribute("tooltiptext") == uri)
		{
			if (account_elem.getAttribute("label") != selection)
			{
				account_elem.setAttribute("label",selection);
			}
			else
			{
				alert(document.getElementById("xpunge_strings").getString("xpunge_multi_str_compact_already_added"));
			}

			return;
		}
	}

	xpunge_multi_appendCompactAccount(selection,uri);

	xpunge_multi_setCompactAccountCounter();
}


function xpunge_multi_doRemoveTrashAccounts () 
{
	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	var selections = accounts.selectedCount;

	while (selections > 0)
	{
		var item = accounts.selectedItems[0];

		var index = accounts.getIndexOfItem(item);

		accounts.removeItemAt(index);

		selections--;
	}

	var rows = accounts.getRowCount();

	if (rows <= 0)
	{
		var button_remove = document.getElementById("xpunge_options_multi_trash_remove");

		button_remove.disabled = true;
	}

	xpunge_multi_setTrashAccountCounter();
}


function xpunge_multi_doRemoveCompactAccounts () 
{
	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	var selections = accounts.selectedCount;

	while (selections > 0)
	{
		var item = accounts.selectedItems[0];

		var index = accounts.getIndexOfItem(item);

		accounts.removeItemAt(index);

		selections--;
	}

	var rows = accounts.getRowCount();

	if (rows <= 0)
	{
		var button_remove = document.getElementById("xpunge_options_multi_compact_remove");

		button_remove.disabled = true;
	}

	xpunge_multi_setCompactAccountCounter();
}


function xpunge_multi_doHandleTrashAccountsFocus ()
{
	var button_add = document.getElementById("xpunge_options_multi_trash_add");

	button_add.disabled = true;

	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	var elems = accounts.getRowCount();

	if (elems > 0)
	{
		var button_remove = document.getElementById("xpunge_options_multi_trash_remove");

		button_remove.disabled = false;
	}

	var compact_accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	compact_accounts.clearSelection();

	var compact_button_add = document.getElementById("xpunge_options_multi_compact_add");
	var compact_button_remove = document.getElementById("xpunge_options_multi_compact_remove");

	compact_button_add.disabled = true;
	compact_button_remove.disabled = true;
}


function xpunge_multi_doHandleCompactAccountsFocus ()
{
	var button_add = document.getElementById("xpunge_options_multi_compact_add");

	button_add.disabled = true;

	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	var elems = accounts.getRowCount();

	if (elems > 0)
	{
		var button_remove = document.getElementById("xpunge_options_multi_compact_remove");

		button_remove.disabled = false;
	}

	var trash_accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	trash_accounts.clearSelection();

	var trash_button_add = document.getElementById("xpunge_options_multi_trash_add");
	var trash_button_remove = document.getElementById("xpunge_options_multi_trash_remove");

	trash_button_add.disabled = true;
	trash_button_remove.disabled = true;
}


function xpunge_multi_doHandleTrashPickerFocus ()
{
	var button_remove = document.getElementById("xpunge_options_multi_trash_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	accounts.clearSelection();

	var compact_accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	compact_accounts.clearSelection();

	var compact_button_add = document.getElementById("xpunge_options_multi_compact_add");
	var compact_button_remove = document.getElementById("xpunge_options_multi_compact_remove");

	compact_button_add.disabled = true;
	compact_button_remove.disabled = true;
}


function xpunge_multi_doHandleCompactPickerFocus ()
{
	var button_remove = document.getElementById("xpunge_options_multi_compact_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	accounts.clearSelection();

	var trash_accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	trash_accounts.clearSelection();

	var trash_button_add = document.getElementById("xpunge_options_multi_trash_add");
	var trash_button_remove = document.getElementById("xpunge_options_multi_trash_remove");

	trash_button_add.disabled = true;
	trash_button_remove.disabled = true;
}


function xpunge_multi_doHandleTrashClearFocus ()
{
	var button_add = document.getElementById("xpunge_options_multi_trash_add");

	button_add.disabled = true;

	var button_remove = document.getElementById("xpunge_options_multi_trash_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	accounts.clearSelection();
}


function xpunge_multi_doHandleCompactClearFocus ()
{
	var button_add = document.getElementById("xpunge_options_multi_compact_add");

	button_add.disabled = true;

	var button_remove = document.getElementById("xpunge_options_multi_compact_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	accounts.clearSelection();
}


function xpunge_multi_fixInvalidSelectedTrashAccounts ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var element = document.getElementById("xpunge_options_multi_trash_accounts");

	if (!element) 
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_fixInvalidSelectedTrashAccounts:" + "\n\n" + "ERROR - Invalid Element: " + "xpunge_options_multi_trash_accounts" + "\n");

		return;
	}

	var eltType = element.localName;

	if (eltType != "listbox")
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_fixInvalidSelectedTrashAccounts:" + "\n\n" + "ERROR - xpunge_options_multi_trash_accounts is not a listbox!" + "\n");

		return;
	}

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = account_value;
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = pref_account + xpunge_multi_TrashAccountSeparator + account_value;
	}

	prefBranch.setCharPref("xpunge.options.multi.trash.accounts",pref_account);
}


function xpunge_multi_fixInvalidSelectedCompactAccounts ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var element = document.getElementById("xpunge_options_multi_compact_accounts");

	if (!element) 
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_fixInvalidSelectedCompactAccounts:" + "\n\n" + "ERROR - Invalid Element: " + "xpunge_options_multi_compact_accounts" + "\n");

		return;
	}

	var eltType = element.localName;

	if (eltType != "listbox")
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_fixInvalidSelectedCompactAccounts:" + "\n\n" + "ERROR - xpunge_options_multi_compact_accounts is not a listbox!" + "\n");

		return;
	}

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = account_value;
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = pref_account + xpunge_multi_CompactAccountSeparator + account_value;
	}

	prefBranch.setCharPref("xpunge.options.multi.compact.accounts",pref_account);
}


function xpunge_multi_ensureTrashAccountIsVisible (index)
{
	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	accounts.ensureIndexIsVisible(index);
}


function xpunge_multi_ensureCompactAccountIsVisible (index)
{
	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	accounts.ensureIndexIsVisible(index);
}


function xpunge_multi_isValidTrashAccountEntry (index, uri, caller)
{
	if (uri == "")
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Empty Account Entry: Index = " + index + "\n");

		return false;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder)
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Invalid Account: " + uri + "\n");

		return false;
	}

	if (!msgfolder.isServer)
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Account Is Not A Server: " + uri + "\n");

		return false;
	}

	if (msgfolder.name == "")
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Account Has No Name: " + uri + "\n");

		return false;
	}

	return true;
}


function xpunge_multi_isValidCompactAccountEntry (index, uri, caller)
{
	if (uri == "")
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidCompactAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Empty Account/Folder Entry: Index = " + index + "\n");

		return false;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder)
	{
		if (!msgfolder.isServer)
		{
			xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidCompactAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Entry Is Not A Server Or A Folder: " + uri + "\n");

			return false;
		}
	}

	if (msgfolder.name == "")
	{
		xpunge_multi_consoleService.logStringMessage("xpunge - xpunge_multi_isValidCompactAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Account/Folder Has No Name: " + uri + "\n");

		return false;
	}

	return true;
}


function xpunge_multi_setTrashAccountCounter ()
{
	var accounts = document.getElementById("xpunge_options_multi_trash_accounts");

	var rows = accounts.getRowCount();

	var label_elem = document.getElementById("xpunge_options_multi_label_trash_accounts");

	var old_label = label_elem.getAttribute("value");

	var field_array = old_label.split(/:/);

	var new_label = field_array[0] + ": " + rows;

	label_elem.setAttribute("value",new_label);
}


function xpunge_multi_setCompactAccountCounter ()
{
	var accounts = document.getElementById("xpunge_options_multi_compact_accounts");

	var rows = accounts.getRowCount();

	var label_elem = document.getElementById("xpunge_options_multi_label_compact_accounts");

	var old_label = label_elem.getAttribute("value");

	var field_array = old_label.split(/:/);

	var new_label = field_array[0] + ": " + rows;

	label_elem.setAttribute("value",new_label);
}

