
var xpunge_timer_consoleService = Components.classes['@mozilla.org/consoleservice;1'].
			getService(Components.interfaces.nsIConsoleService);

var xpunge_timer_ElementIDs =	[
					"xpunge_options_timer_auto_check", "xpunge_options_timer_auto_startup",
					"xpunge_options_timer_auto_loop", "xpunge_options_timer_singleton_check"
				];

const xpunge_timer_NO_URI = "none";

var xpunge_timer_TrashAccountSeparator = "   ";
var xpunge_timer_CompactAccountSeparator = "   ";

var xpunge_timer_TrashAccountSeparatorRegExp = /   /;
var xpunge_timer_CompactAccountSeparatorRegExp = /   /;



function xpunge_timer_LoadOptions () 
{
	xpunge_timer_LoadOtherOptions();
	xpunge_timer_LoadTrashOptions();
	xpunge_timer_LoadCompactOptions();

	xpunge_timer_doHandleTimerState();
}


function xpunge_timer_LoadOtherOptions () 
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var element = document.getElementById("xpunge_options_timer_singleton_check");
	element.checked = prefBranch.getBoolPref(element.getAttribute("prefstring"));

	var element = document.getElementById("xpunge_options_timer_auto_check");
	element.checked = prefBranch.getBoolPref(element.getAttribute("prefstring"));

	element = document.getElementById("xpunge_options_timer_auto_startup");
	var num_str = prefBranch.getCharPref(element.getAttribute("prefstring"));

	if (!xpunge_timer_checkStartupInterval(num_str))
		element.value = "0";
	else
		element.value = num_str;

	element = document.getElementById("xpunge_options_timer_auto_loop");
	num_str = prefBranch.getCharPref(element.getAttribute("prefstring"));

	if (!xpunge_timer_checkLoopInterval(num_str))
		element.value = "0";
	else
		element.value = num_str;
}


function xpunge_timer_LoadTrashOptions ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var pref_trash_account = prefBranch.getCharPref("xpunge.options.timer.trash.accounts");

	if (pref_trash_account == "")
	{
		xpunge_timer_setTrashAccountCounter();
	}
	else
	{
		var trash_account_array = pref_trash_account.split(xpunge_timer_TrashAccountSeparatorRegExp);

		var do_fix_trash = false;

		for (var j = 0; j < trash_account_array.length; j++)
		{
			if (!xpunge_timer_isValidTrashAccountEntry(j,trash_account_array[j],"xpunge_timer_LoadTrashOptions"))
			{
				do_fix_trash = true;

				continue;
			}

			var msgfolder = GetMsgFolderFromUri(trash_account_array[j],true);

			xpunge_timer_appendTrashAccount(msgfolder.name,trash_account_array[j]);
		}

		xpunge_timer_ensureTrashAccountIsVisible(0);
		xpunge_timer_setTrashAccountCounter();

		if (do_fix_trash)
			xpunge_timer_fixInvalidSelectedTrashAccounts();
	}
}


function xpunge_timer_LoadCompactOptions ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var pref_compact_account = prefBranch.getCharPref("xpunge.options.timer.compact.accounts");

	if (pref_compact_account == "")
	{
		xpunge_timer_setCompactAccountCounter();
	}
	else
	{
		var compact_account_array = pref_compact_account.split(xpunge_timer_CompactAccountSeparatorRegExp);

		var do_fix_compact = false;

		for (var j = 0; j < compact_account_array.length; j++)
		{
			if (!xpunge_timer_isValidCompactAccountEntry(j,compact_account_array[j],"xpunge_timer_LoadCompactOptions"))
			{
				do_fix_compact = true;

				continue;
			}

			var msgfolder = GetMsgFolderFromUri(compact_account_array[j],true);

			var item_name;
			var server_name;

			if (msgfolder.isServer)
			{
				item_name = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_whole");
			}
			else
			{
				if (msgfolder.server)
					server_name = msgfolder.server.prettyName;
				else
				{
					xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_LoadCompactOptions:" + "\n\n" + "ERROR - Can't find server for " + compact_account_array[j] + "\n");
					server_name = "???";
				}

				item_name = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_belongs") + " " + server_name;
			}

			xpunge_timer_appendCompactAccount(item_name,compact_account_array[j]);
		}

		xpunge_timer_ensureCompactAccountIsVisible(0);
		xpunge_timer_setCompactAccountCounter();

		if (do_fix_compact)
			xpunge_timer_fixInvalidSelectedCompactAccounts();
	}
}


function xpunge_timer_SaveOptions () 
{
	xpunge_timer_SaveOtherOptions();
	xpunge_timer_SaveTrashOptions();
	xpunge_timer_SaveCompactOptions();
}


function xpunge_timer_SaveOtherOptions () 
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	for (var i = 0; i < xpunge_timer_ElementIDs.length; i++)
	{
		var element = document.getElementById(xpunge_timer_ElementIDs[i]);

		if (!element) 
		{
			xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_SaveOtherOptions:" + "\n\n" + "ERROR - Invalid Element: " + xpunge_timer_ElementIDs[i] + "\n");

			continue;
		}

		var eltType = element.localName;

		if (eltType == "textbox")
		{
			prefBranch.setCharPref(element.getAttribute("prefstring"),element.value);
		}
		else if (eltType == "checkbox")
		{
			prefBranch.setBoolPref(element.getAttribute("prefstring"),element.checked);
		}
	}
}


function xpunge_timer_SaveTrashOptions () 
{
	var log_msg = "";
	var do_fix = false;

	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_timer_isValidTrashAccountEntry(0,account_value,"xpunge_timer_SaveTrashOptions"))
		{
			pref_account = account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + "0" + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_timer_isValidTrashAccountEntry(j,account_value,"xpunge_timer_SaveTrashOptions"))
		{
			pref_account = pref_account + xpunge_timer_TrashAccountSeparator + account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + j + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}

	prefBranch.setCharPref("xpunge.options.timer.trash.accounts",pref_account);

	if (do_fix)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_SaveTrashOptions:" + "\n\n" + log_msg + "\n");

		alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_trash_save_fixed_msg"));
	}
}


function xpunge_timer_SaveCompactOptions () 
{
	var log_msg = "";
	var do_fix = false;

	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_timer_isValidCompactAccountEntry(0,account_value,"xpunge_timer_SaveCompactOptions"))
		{
			pref_account = account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + "0" + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		if (xpunge_timer_isValidCompactAccountEntry(j,account_value,"xpunge_timer_SaveCompactOptions"))
		{
			pref_account = pref_account + xpunge_timer_CompactAccountSeparator + account_value;
		}
		else
		{
			do_fix = true;

			log_msg = log_msg +
				"Row = " + j + "     " +
				"Label = " + account_elem.getAttribute('label') + "     " +
				"\n\n";
		}
	}

	prefBranch.setCharPref("xpunge.options.timer.compact.accounts",pref_account);

	if (do_fix)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_SaveCompactOptions:" + "\n\n" + log_msg + "\n");

		alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_save_fixed_msg"));
	}
}


function xpunge_timer_appendTrashAccount (v_account, v_tooltip)
{
	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	accounts.appendItem(v_account);

	var item = accounts.getItemAtIndex(accounts.getRowCount()-1);

	item.setAttribute('tooltiptext',v_tooltip);

	xpunge_timer_ensureTrashAccountIsVisible(accounts.getRowCount()-1);
}


function xpunge_timer_appendCompactAccount (v_account, v_tooltip)
{
	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	accounts.appendItem(v_account);

	var item = accounts.getItemAtIndex(accounts.getRowCount()-1);

	item.setAttribute('tooltiptext',v_tooltip);

	xpunge_timer_ensureCompactAccountIsVisible(accounts.getRowCount()-1);
}


function xpunge_timer_SetTrashFolderPicker (selection, pickerID, defaultURI)
{
	var picker = document.getElementById(pickerID);

	var uri;

	if (selection != null)
	{
		uri = selection.getAttribute('id');
	}
	else
	{
		uri = defaultURI;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder) 
	{
		picker.setAttribute("uri",xpunge_timer_NO_URI);
	}
	else
	{
		picker.setAttribute("uri",uri);

		var button_add = document.getElementById("xpunge_options_timer_trash_add");

		button_add.disabled = false;
	}
}


function xpunge_timer_SetCompactFolderPicker (selection, pickerID, defaultURI)
{
	var picker = document.getElementById(pickerID);

	var uri;

	if (selection != null)
	{
		uri = selection.getAttribute('id');
	}
	else
	{
		uri = defaultURI;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder) 
	{
		picker.setAttribute("uri",xpunge_timer_NO_URI);
	}
	else
	{
		var selectedValue = null;
		var serverName;

		if (msgfolder.isServer)
			selectedValue = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_whole");
		else
		{
			if (msgfolder.server)
				serverName = msgfolder.server.prettyName;
			else
			{
				xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_SetCompactFolderPicker:" + "\n\n" + "ERROR - Can't find server for " + uri + "\n");
				serverName = "???";
			}

			selectedValue = msgfolder.name + " " + document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_belongs") + " " + serverName;
		}

		picker.setAttribute("label",selectedValue);
		picker.setAttribute("uri",uri);

		var button_add = document.getElementById("xpunge_options_timer_compact_add");

		button_add.disabled = false;
	}
}


function xpunge_timer_doAddTrashAccounts () 
{
	var picker = document.getElementById("xpunge_options_timer_trash_picker");

	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	var selection = picker.getAttribute("label");

	var uri = picker.getAttribute("uri");

	if (uri == xpunge_timer_NO_URI)
	{
		alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_trash_invalid_account"));

		return;
	}

	var rows = accounts.getRowCount();

	for (var i = 0; i < rows; i++)
	{
		var account_elem = accounts.getItemAtIndex(i);

		if (account_elem.getAttribute("tooltiptext") == uri)
		{
			if (account_elem.getAttribute("label") != selection)
			{
				account_elem.setAttribute("label",selection);
			}
			else
			{
				alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_trash_already_added"));
			}

			return;
		}
	}

	xpunge_timer_appendTrashAccount(selection,uri);

	xpunge_timer_setTrashAccountCounter();

	xpunge_timer_doHandleTimerState();
}


function xpunge_timer_doAddCompactAccounts () 
{
	var picker = document.getElementById("xpunge_options_timer_compact_picker");

	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var selection = picker.getAttribute("label");

	var uri = picker.getAttribute("uri");

	if (uri == xpunge_timer_NO_URI)
	{
		alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_invalid_account"));

		return;
	}

	var rows = accounts.getRowCount();

	for (var i = 0; i < rows; i++)
	{
		var account_elem = accounts.getItemAtIndex(i);

		if (account_elem.getAttribute("tooltiptext") == uri)
		{
			if (account_elem.getAttribute("label") != selection)
			{
				account_elem.setAttribute("label",selection);
			}
			else
			{
				alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_compact_already_added"));
			}

			return;
		}
	}

	xpunge_timer_appendCompactAccount(selection,uri);

	xpunge_timer_setCompactAccountCounter();

	xpunge_timer_doHandleTimerState();
}


function xpunge_timer_doRemoveTrashAccounts () 
{
	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	var selections = accounts.selectedCount;

	while (selections > 0)
	{
		var item = accounts.selectedItems[0];

		var index = accounts.getIndexOfItem(item);

		accounts.removeItemAt(index);

		selections--;
	}

	var rows = accounts.getRowCount();

	if (rows <= 0)
	{
		var button_remove = document.getElementById("xpunge_options_timer_trash_remove");

		button_remove.disabled = true;
	}

	xpunge_timer_setTrashAccountCounter();

	xpunge_timer_doHandleTimerState();
}


function xpunge_timer_doRemoveCompactAccounts () 
{
	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var selections = accounts.selectedCount;

	while (selections > 0)
	{
		var item = accounts.selectedItems[0];

		var index = accounts.getIndexOfItem(item);

		accounts.removeItemAt(index);

		selections--;
	}

	var rows = accounts.getRowCount();

	if (rows <= 0)
	{
		var button_remove = document.getElementById("xpunge_options_timer_compact_remove");

		button_remove.disabled = true;
	}

	xpunge_timer_setCompactAccountCounter();

	xpunge_timer_doHandleTimerState();
}


function xpunge_timer_doHandleTrashAccountsFocus ()
{
	var button_add = document.getElementById("xpunge_options_timer_trash_add");

	button_add.disabled = true;

	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	var elems = accounts.getRowCount();

	if (elems > 0)
	{
		var button_remove = document.getElementById("xpunge_options_timer_trash_remove");

		button_remove.disabled = false;
	}

	var compact_accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	compact_accounts.clearSelection();

	var compact_button_add = document.getElementById("xpunge_options_timer_compact_add");
	var compact_button_remove = document.getElementById("xpunge_options_timer_compact_remove");

	compact_button_add.disabled = true;
	compact_button_remove.disabled = true;
}


function xpunge_timer_doHandleCompactAccountsFocus ()
{
	var button_add = document.getElementById("xpunge_options_timer_compact_add");

	button_add.disabled = true;

	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var elems = accounts.getRowCount();

	if (elems > 0)
	{
		var button_remove = document.getElementById("xpunge_options_timer_compact_remove");

		button_remove.disabled = false;
	}

	var trash_accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	trash_accounts.clearSelection();

	var trash_button_add = document.getElementById("xpunge_options_timer_trash_add");
	var trash_button_remove = document.getElementById("xpunge_options_timer_trash_remove");

	trash_button_add.disabled = true;
	trash_button_remove.disabled = true;
}


function xpunge_timer_doHandleTrashPickerFocus ()
{
	var button_remove = document.getElementById("xpunge_options_timer_trash_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	accounts.clearSelection();

	var compact_accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	compact_accounts.clearSelection();

	var compact_button_add = document.getElementById("xpunge_options_timer_compact_add");
	var compact_button_remove = document.getElementById("xpunge_options_timer_compact_remove");

	compact_button_add.disabled = true;
	compact_button_remove.disabled = true;
}


function xpunge_timer_doHandleCompactPickerFocus ()
{
	var button_remove = document.getElementById("xpunge_options_timer_compact_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	accounts.clearSelection();

	var trash_accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	trash_accounts.clearSelection();

	var trash_button_add = document.getElementById("xpunge_options_timer_trash_add");
	var trash_button_remove = document.getElementById("xpunge_options_timer_trash_remove");

	trash_button_add.disabled = true;
	trash_button_remove.disabled = true;
}


function xpunge_timer_doHandleTrashClearFocus ()
{
	var button_add = document.getElementById("xpunge_options_timer_trash_add");

	button_add.disabled = true;

	var button_remove = document.getElementById("xpunge_options_timer_trash_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	accounts.clearSelection();
}


function xpunge_timer_doHandleCompactClearFocus ()
{
	var button_add = document.getElementById("xpunge_options_timer_compact_add");

	button_add.disabled = true;

	var button_remove = document.getElementById("xpunge_options_timer_compact_remove");

	button_remove.disabled = true;

	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	accounts.clearSelection();
}


function xpunge_timer_fixInvalidSelectedTrashAccounts ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var element = document.getElementById("xpunge_options_timer_trash_accounts");

	if (!element) 
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_fixInvalidSelectedTrashAccounts:" + "\n\n" + "ERROR - Invalid Element: " + "xpunge_options_timer_trash_accounts" + "\n");

		return;
	}

	var eltType = element.localName;

	if (eltType != "listbox")
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_fixInvalidSelectedTrashAccounts:" + "\n\n" + "ERROR - xpunge_options_timer_trash_accounts is not a listbox!" + "\n");

		return;
	}

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = account_value;
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = pref_account + xpunge_timer_TrashAccountSeparator + account_value;
	}

	prefBranch.setCharPref("xpunge.options.timer.trash.accounts",pref_account);
}


function xpunge_timer_fixInvalidSelectedCompactAccounts ()
{
	var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch); 

	var element = document.getElementById("xpunge_options_timer_compact_accounts");

	if (!element) 
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_fixInvalidSelectedCompactAccounts:" + "\n\n" + "ERROR - Invalid Element: " + "xpunge_options_timer_compact_accounts" + "\n");

		return;
	}

	var eltType = element.localName;

	if (eltType != "listbox")
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_fixInvalidSelectedCompactAccounts:" + "\n\n" + "ERROR - xpunge_options_timer_compact_accounts is not a listbox!" + "\n");

		return;
	}

	var account_elem;

	var account_value;

	var pref_account = "";

	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var rows = accounts.getRowCount();

	if (rows > 0)
	{
		account_elem = accounts.getItemAtIndex(0);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = account_value;
	}
	
	for (var j = 1; j < rows; j++)
	{
		account_elem = accounts.getItemAtIndex(j);

		account_value = account_elem.getAttribute("tooltiptext");

		pref_account = pref_account + xpunge_timer_CompactAccountSeparator + account_value;
	}

	prefBranch.setCharPref("xpunge.options.timer.compact.accounts",pref_account);
}


function xpunge_timer_ensureTrashAccountIsVisible (index)
{
	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	accounts.ensureIndexIsVisible(index);
}


function xpunge_timer_ensureCompactAccountIsVisible (index)
{
	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	accounts.ensureIndexIsVisible(index);
}


function xpunge_timer_isValidTrashAccountEntry (index, uri, caller)
{
	if (uri == "")
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Empty Account Entry: Index = " + index + "\n");

		return false;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Invalid Account: " + uri + "\n");

		return false;
	}

	if (!msgfolder.isServer)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Account Is Not A Server: " + uri + "\n");

		return false;
	}

	if (msgfolder.name == "")
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidTrashAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Account Has No Name: " + uri + "\n");

		return false;
	}

	return true;
}


function xpunge_timer_isValidCompactAccountEntry (index, uri, caller)
{
	if (uri == "")
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidCompactAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Empty Account/Folder Entry: Index = " + index + "\n");

		return false;
	}

	var msgfolder = GetMsgFolderFromUri(uri,true);

	if (!msgfolder)
	{
		if (!msgfolder.isServer)
		{
			xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidCompactAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Entry Is Not A Server Or A Folder: " + uri + "\n");

			return false;
		}
	}

	if (msgfolder.name == "")
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_isValidCompactAccountEntry(" + caller + "):" + "\n\n" + "WARNING - Account/Folder Has No Name: " + uri + "\n");

		return false;
	}

	return true;
}


function xpunge_timer_setTrashAccountCounter ()
{
	var accounts = document.getElementById("xpunge_options_timer_trash_accounts");

	var rows = accounts.getRowCount();

	var label_elem = document.getElementById("xpunge_options_timer_label_trash_accounts");

	var old_label = label_elem.getAttribute("value");

	var field_array = old_label.split(/:/);

	var new_label = field_array[0] + ": " + rows;

	label_elem.setAttribute("value",new_label);
}


function xpunge_timer_setCompactAccountCounter ()
{
	var accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var rows = accounts.getRowCount();

	var label_elem = document.getElementById("xpunge_options_timer_label_compact_accounts");

	var old_label = label_elem.getAttribute("value");

	var field_array = old_label.split(/:/);

	var new_label = field_array[0] + ": " + rows;

	label_elem.setAttribute("value",new_label);
}


function xpunge_timer_updateTimerFocusItems ()
{
	var focus_element = document.getElementById("xpunge_options_timer_auto_check");
	var focus_startup = document.getElementById("xpunge_options_timer_auto_startup");
	var focus_loop = document.getElementById("xpunge_options_timer_auto_loop");

	if (focus_element.checked)
	{
		focus_startup.disabled = false;
		focus_loop.disabled = false;
	}
	else
	{
		focus_startup.disabled = true;
		focus_loop.disabled = true;
	}
}


function xpunge_timer_checkStartupIntervalInput (elem)
{
	if ((elem.value.search(/[^0-9]/) != -1) || (elem.value.length <= 0))
	{
		alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_startup_invalid_integer") + ": " + elem.value);
		elem.value = "0";
	}
}


function xpunge_timer_checkLoopIntervalInput (elem)
{
	if ((elem.value.search(/[^0-9]/) != -1) || (elem.value.length <= 0))
	{
		alert(document.getElementById("xpunge_strings").getString("xpunge_timer_str_loop_invalid_integer") + ": " + elem.value);
		elem.value = "0";
	}
}


function xpunge_timer_checkStartupInterval (interval_str)
{
	if (interval_str.length <= 0)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_checkStartupInterval:" + "\n\n" + "WARNING - Empty startup timer interval preference: " + interval_str + "\n");

		return false;
	}

	if (interval_str.search(/[^0-9]/) != -1)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_checkStartupInterval:" + "\n\n" + "WARNING - Invalid startup timer interval preference: " + interval_str + "\n");

		return false;
	}

	return true;
}


function xpunge_timer_checkLoopInterval (interval_str)
{
	if (interval_str.length <= 0)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_checkLoopInterval:" + "\n\n" + "WARNING - Empty loop timer interval preference: " + interval_str + "\n");

		return false;
	}

	if (interval_str.search(/[^0-9]/) != -1)
	{
		xpunge_timer_consoleService.logStringMessage("xpunge - xpunge_timer_checkLoopInterval:" + "\n\n" + "WARNING - Invalid loop timer interval preference: " + interval_str + "\n");

		return false;
	}

	return true;
}


function xpunge_timer_doHandleTimerState ()
{
	var trash_accounts = document.getElementById("xpunge_options_timer_trash_accounts");
	var compact_accounts = document.getElementById("xpunge_options_timer_compact_accounts");

	var timer_check = document.getElementById("xpunge_options_timer_auto_check");
	var timer_startup = document.getElementById("xpunge_options_timer_auto_startup");
	var timer_label_startup = document.getElementById("xpunge_options_timer_auto_label_startup_suffix");
	var timer_loop = document.getElementById("xpunge_options_timer_auto_loop");
	var timer_label_loop = document.getElementById("xpunge_options_timer_auto_label_loop_suffix");
	var timer_singleton = document.getElementById("xpunge_options_timer_singleton_check");

	var trash_elems = trash_accounts.getRowCount();
	var compact_elems = compact_accounts.getRowCount();

	if ((trash_elems > 0) || (compact_elems > 0))
	{
		timer_check.disabled = false;
		timer_startup.disabled = false;
		timer_label_startup.disabled = false;
		timer_loop.disabled = false;
		timer_label_loop.disabled = false;
		timer_singleton.disabled = false;

		xpunge_timer_updateTimerFocusItems();
	}
	else
	{
		timer_check.checked = false;
		timer_check.disabled = true;
		timer_startup.disabled = true;
		timer_label_startup.disabled = true;
		timer_loop.disabled = true;
		timer_label_loop.disabled = true;
		timer_singleton.disabled = true;
	}
}

